/*# include <bits/stdc++.h>
using namespace std;
int main ()
{
    long long a, b, maxi=-1, mini=99999, i, j, minians=0, maxians=0, suma=0;
    double trivialnost;
    cin>>a>>b;
    for (i=a;i<=b;i++)
    {
        suma=0;
        for (j=1;j<=i;j++)
        {
            if (i%j==0)suma=suma+j;
        }
        trivialnost=suma/i;
        if (trivialnost>maxi){maxi=trivialnost;maxians=i;}
        if (trivialnost<mini){mini=trivialnost;minians=i;}
    }
   cout<<minians<<" "<<maxians<<endl;
    return 0;*/
<!-->
  -- Copyright (c) 1996-1999
  -- Silicon Graphics Computer Systems, Inc.
  --
  -- Permission to use, copy, modify, distribute and sell this software
  -- and its documentation for any purpose is hereby granted without fee,
  -- provided that the above copyright notice appears in all copies and
  -- that both that copyright notice and this permission notice appear
  -- in supporting documentation.  Silicon Graphics makes no
  -- representations about the suitability of this software for any
  -- purpose.  It is provided "as is" without express or implied warranty.
  --
  -- Copyright (c) 1994
  -- Hewlett-Packard Company
  --
  -- Permission to use, copy, modify, distribute and sell this software
  -- and its documentation for any purpose is hereby granted without fee,
  -- provided that the above copyright notice appears in all copies and
  -- that both that copyright notice and this permission notice appear
  -- in supporting documentation.  Hewlett-Packard Company makes no
  -- representations about the suitability of this software for any
  -- purpose.  It is provided "as is" without express or implied warranty.
  --
  -->
<Head>
<Title>Trivial Iterator</Title>
<!-- Generated by htmldoc -->
</HEAD>
<BODY BGCOLOR="#ffffff" LINK="#0000ee" TEXT="#000000" VLINK="#551a8b"
	ALINK="#ff0000">
<IMG SRC="CorpID.gif"
     ALT="SGI" HEIGHT="43" WIDTH="151">
<!--end header-->
<BR Clear>
<H1>Trivial Iterator</H1>

<Table CellPadding=0 CellSpacing=0 width=100%>
<TR>
<TD Align=left><Img src = "iterators.gif" Alt=""   WIDTH = "194"  HEIGHT = "38" ></TD>
<TD Align=right><Img src = "concept.gif" Alt=""   WIDTH = "194"  HEIGHT = "38" ></TD>
</TR>
<TR>
<TD Align=left VAlign=top><b>Category</b>: iterators</TD>
<TD Align=right VAlign=top><b>Component type</b>: concept</TD>
</TR>
</Table>

<h3>Description</h3>
A Trivial Iterator is an object that may be dereferenced to refer to
some other object.  Arithmetic operations (such as increment and
comparison) are not guaranteed to be supported.
<h3>Refinement of</h3>
<A href="Assignable.html">Assignable</A>,
<A href="EqualityComparable.html">Equality Comparable</A>,
<A href="DefaultConstructible.html">Default Constructible</A>
<h3>Associated types</h3>
<Table border>
<TR>
<TD VAlign=top>
Value type
</TD>
<TD VAlign=top>
The type of the value obtained by dereferencing a Trivial Iterator
</TD>
</tr>
</table>
<h3>Notation</h3>
<Table>
<TR>
<TD VAlign=top>
<tt>X</tt>
</TD>
<TD VAlign=top>
A type that is a model of Trivial Iterator
</TD>
</TR>
<TR>
<TD VAlign=top>
<tt>T</tt>
</TD>
<TD VAlign=top>
The value type of <tt>X</tt>
</TD>
</TR>
<TR>
<TD VAlign=top>
<tt>x</tt>, <tt>y</tt>
</TD>
<TD VAlign=top>
Object of type <tt>X</tt>
</TD>
</TR>
<TR>
<TD VAlign=top>
<tt>t</tt>
</TD>
<TD VAlign=top>
Object of type <tt>T</tt>
</TD>
</tr>
</table>
<h3>Definitions</h3>
A type that is a model of Trivial Iterator may be <i>mutable</i>,
meaning that the values referred to by objects of that type may be
modified, or <i>constant</i>, meaning that they may not.  For example,
<tt>int*</tt> is a mutable iterator type and <tt>const int*</tt> is a
constant iterator type.  If an iterator type is mutable, this implies
that its value type is a model of
<A href="Assignable.html">Assignable</A>; the converse, though, is not
necessarily true.
<P>
A Trivial Iterator may have a <i>singular</i> value, meaning that the
results of most operations, including comparison for equality, are
undefined.  The only operation that a is guaranteed to be supported is
assigning a nonsingular iterator to a singular iterator.
<P>
A Trivial Iterator may have a <i>dereferenceable</i> value, meaning
that dereferencing it yields a well-defined value.  Dereferenceable
iterators are always nonsingular, but the converse is not true.  For
example, a null pointer is nonsingular (there are well defined
operations involving null pointers) even thought it is not
dereferenceable.
<P>
<i>Invalidating</i> a dereferenceable iterator means performing an
operation after which the iterator might be nondereferenceable or
singular.  For example, if <tt>p</tt> is a pointer, then <tt>delete
p</tt> invalidates <tt>p</tt>.
<h3>Valid expressions</h3>
In addition to the expressions defined in
<A href="Assignable.html">Assignable</A>,
<A href="EqualityComparable.html">Equality Comparable</A>, and
<A href="DefaultConstructible.html">Default Constructible</A>, the
following expressions must be valid.
<Table border>
<TR>
<TH>
Name
</TH>
<TH>
Expression
</TH>
<TH>
Type requirements
</TH>
<TH>
Return type
</TH>
</TR>
<TR>
<TD VAlign=top>
Default constructor
</TD>
<TD VAlign=top>
<tt>X x</tt>
</TD>
<TD VAlign=top>
&nbsp;
</TD>
<TD VAlign=top>
&nbsp;
</TD>
</TR>
<TR>
<TD VAlign=top>
Dereference
</TD>
<TD VAlign=top>
<tt>*x</tt>
</TD>
<TD VAlign=top>
&nbsp;
</TD>
<TD VAlign=top>
Convertible to <tt>T</tt> <A href="#1">[1]</A>
</TD>
</TR>
<TR>
<TD VAlign=top>
Dereference assignment
</TD>
<TD VAlign=top>
<tt>*x = t</tt>
</TD>
<TD VAlign=top>
<tt>X</tt> is mutable
</TD>
<TD VAlign=top>
&nbsp;
</TD>
</TR>
<TR>
<TD VAlign=top>
Member access
</TD>
<TD VAlign=top>
<tt>x-&gt;m</tt> <A href="#2">[2]</A>
</TD>
<TD VAlign=top>
<tt>T</tt> is a type for which <tt>x.m</tt> is defined
</TD>
<TD VAlign=top>
&nbsp;
</TD>
</tr>
</table>
<h3>Expression semantics</h3>
<Table border>
<TR>
<TH>
Name
</TH>
<TH>
Expression
</TH>
<TH>
Precondition
</TH>
<TH>
Semantics
</TH>
<TH>
Postcondition
</TH>
</TR>
<TR>
<TD VAlign=top>
Default constructor
</TD>
<TD VAlign=top>
<tt>X x</tt>
</TD>
<TD VAlign=top>
&nbsp;
</TD>
<TD VAlign=top>
&nbsp;
</TD>
<TD VAlign=top>
<tt>x</tt> is singular
</TD>
</TR>
<TR>
<TD VAlign=top>
Dereference
</TD>
<TD VAlign=top>
<tt>*x</tt>
</TD>
<TD VAlign=top>
<tt>x</tt> is dereferenceable
</TD>
<TD VAlign=top>
&nbsp;
</TD>
<TD VAlign=top>
&nbsp;
</TD>
</TR>
<TR>
<TD VAlign=top>
Dereference assignment
</TD>
<TD VAlign=top>
<tt>*x = t</tt>
</TD>
<TD VAlign=top>
<tt>x</tt> is dereferenceable
</TD>
<TD VAlign=top>
&nbsp;
</TD>
<TD VAlign=top>
<tt>*x</tt> is a copy of t
</TD>
</TR>
<TR>
<TD VAlign=top>
Member access
</TD>
<TD VAlign=top>
<tt>x-&gt;m</tt>
</TD>
<TD VAlign=top>
<tt>x</tt> is dereferenceable
</TD>
<TD VAlign=top>
Equivalent to <tt>(*x).m</tt>
</TD>
<TD VAlign=top>
&nbsp;
</TD>
</tr>
</table>
<h3>Complexity guarantees</h3>
The complexity of operations on trivial iterators is
guaranteed to be amortized constant time.
<h3>Invariants</h3>
<Table border>
<TR>
<TD VAlign=top>
Identity
</TD>
<TD VAlign=top>
<tt>x == y</tt> if and only if <tt>&amp;*x == &amp;*y</tt>
</TD>
</tr>
</table>
<h3>Models</h3>
<UL>
<LI>
A pointer to an object that is not part of an array.
</UL>
<h3>Notes</h3>
<P><A name="1">[1]</A>
The requirement for the return type of <tt>*x</tt> is specified as
&quot;convertible to <tt>T</tt>&quot;, rather than simply <tt>T</tt>,
because it sometimes makes sense for an iterator to return some sort
of proxy object instead of the object that the iterator conceptually
points to.  Proxy objects are implementation details rather than part
of an interface (one use of them, for example, is to allow an iterator
to behave differently depending on whether its value is being read or
written), so the value type of an iterator that returns a proxy is
still <tt>T</tt>.
<P><A name="2">[2]</A>
Defining <tt>operator-&gt;</tt> for iterators depends on a feature that is part
of the C++ language but that is not yet implemented by all C++
compilers.  If your compiler does not yet support this feature, the
workaround is to use <tt>(*it).m</tt> instead of <tt>it-&gt;m</tt>.
<h3>See also</h3>
<A href="InputIterator.html">Input Iterator</A>, <A href="OutputIterator.html">Output Iterator</A>, <A href="ForwardIterator.html">Forward Iterator</A>,
<A href="BidirectionalIterator.html">Bidirectional Iterator</A>, <A href="RandomAccessIterator.html">Random Access Iterator</A>,
<A href="Iterators.html">Iterator Overview</A>

<!--start footer-->
<HR SIZE="6">
<A href="http://www.sgi.com/"><IMG SRC="surf.gif" HEIGHT="54" WIDTH="54"
        ALT="[Silicon Surf]"></A>
<A HREF="index.html"><IMG SRC="stl_home.gif"
        HEIGHT="54" WIDTH="54" ALT="[STL Home]"></A>
<BR>
<FONT SIZE="-2">
<A href="http://www.sgi.com/Misc/sgi_info.html" TARGET="_top">Copyright &copy;
1999 Silicon Graphics, Inc.</A> All Rights Reserved.</FONT>
<FONT SIZE="-3"><a href="http://www.sgi.com/Misc/external.list.html" TARGET="_top">TrademarkInformation</A>
</FONT>
<P>
</BODY>
</HTML>

}
